using System;
using System.Xml;
using System.Xml.XPath;
using Syndication.Extensibility;
using System.IO;
using System.Text.RegularExpressions;
using System.Text;

namespace BlogThisUrl
{
	class BlogThisUrlPlugin : IBlogThis
	{
		XPathNavigator _rss;

		public void BlogItem(IXPathNavigable itemRss)
		{
			_rss = itemRss.CreateNavigator();
			string assemblyUri = this.GetType().Assembly.CodeBase;
			string assemblyPath = new Uri(assemblyUri).LocalPath;
			string assemblyDir = Path.GetDirectoryName(assemblyPath);
			string templateFileName = Path.Combine(assemblyDir, "BlogThisUrl.template");

			string template;
			using (TextReader cmdReader = File.OpenText(templateFileName))
			{
				template = cmdReader.ReadToEnd();
			}
			Regex cmdXpaths = new Regex(@"<\$(?<xpath>.*?)\$>");
			string command = cmdXpaths.Replace(template, new MatchEvaluator(FillInXPaths));
			System.Diagnostics.Process.Start(command);
		}

		private string FillInXPaths(Match match)
		{
			string result;

			string xpath = match.Groups["xpath"].Value;
			object xpathResult = _rss.Evaluate(xpath);

			XPathNodeIterator iterator = xpathResult as XPathNodeIterator;
			if(iterator != null)
			{
				StringBuilder resultBuilder = new StringBuilder();
				while (iterator.MoveNext())
				{
					resultBuilder.Append(iterator.Current.ToString());
				}
				result = resultBuilder.ToString();
			}
			else
			{
				result = xpathResult.ToString();
			}

			return System.Web.HttpUtility.UrlEncode(result);
		}

		[STAThread]
		static void Main(string[] args)
		{
			Console.WriteLine("This is a BlogThis plugin - see http://www.pocketsoap.com/weblog for more information");
		}
	}
}
